/**
 * Constants is a set of globally defined constants.
 *
 * @author Joshua Thompson
 * @date 12/01/01
 * @version 1.0
 */
//Version History
//  12/01/01 Joshua Thompson added java source code

public class Constants
{
    /**
     * the maximum number of rows in a map.
     */
    public static final int maxRow = 20;
    /**
     * the maximum number of columns in a map.
     */
    public static final int maxCol = 25;
    /**
     * the size of the square graphics in the x direction.
     */
    public static final int gSizeX = 24;
    /**
     * the size of the square graphics in the y direction.
     */
    public static final int gSizeY = 24;
    /**
     * the x coordinate of the normal window size.
     */
    public static final int normalResX = 720;
    /**
     * the y coordinate of the normal window size.
     */
    public static final int normalResY = 540;
    /**
     * the x coordinate of the multiplayer window size.
     */
    public static final int multiResX = 720;
    /**
     * the y coordinate of the multiplayer window size.
     */
    public static final int multiResY = 650;
    /**
     * the maximum number of saved games.
     */
    public static final int maxSaves = 15;
    /**
     * The directory path to where the levels are stored.
     */
    public static final String levelPath = ".\\levels\\";
    /**
     * The directory path to where the graphics are stored.
     */
    public static final String graphicsPath = ".\\graphics\\";
    /**
     * The directory path to where the saved games are stored.
     */
    public static final String savePath = ".\\save\\";
    /**
     * The directory path to where the level list is stored.
     */
    public static final String levelList = ".\\levels\\levels.lst";
    /**
     * The directory path to where the tutorial files are stored.
     */
    public static final String tutPath=".\\tutorial\\";
    /**
     * The directory path to where the help files are stored.
     */
    public static final String helpPath = ".\\help\\";
    /**
     * the String file name for the instructions.
     */
    public static final String instructionsFile = "instructions.txt";
    /**
     * the String file name for the host game instructions.
     */
    public static final String helpHostFile = "hosthelp.txt";
    /**
     * the String file name for the join game instructions.
     */
    public static final String helpJoinFile = "joinhelp.txt";
    /**
     * the String file name extension for level files.
     */
    public static final String levelExt = ".lvl";
    /**
     * the String file name extension for save game files
     */
    public static final String saveExt = ".sav";
    /**
     * The String file name for the level editor help file
     */
    public static final String helpLevelEditorFile = "leveleditorhelp.txt";
}
