/**
 * <p>The Direction class extends the Enumerate class and represents the four
 * directions a Robot can move on a map.  The four directions that a robot can
 * move are up, down, left and right.</p>
 *
 * @author Joshua Thompson
 * @date 11/27/2001
 * @version 1.1
 *
 */
//Version History
//  11/27/01 Joshua Thompson added algorithm pseudocode
//  11/28/01 Joshua Thompson fixed javadoc headers

public class Direction extends Enumerate
{
    public static final Direction UP = new Direction("UP");
    public static final Direction DOWN = new Direction("DOWN");
    public static final Direction LEFT = new Direction("LEFT");
    public static final Direction RIGHT = new Direction("RIGHT");

    /**
     * <p>Constructor - calls the constructor of the Enumerate class that
     * Direction inherits.</p>
     *
     * @param name the name of the direction: up, down, left or right
     */
    public Direction (String name)
    {
        // CALL Enumerate constructor with super(name)
        super(name);
    }
}
