/**
 * HighScore is a score obtained by a user which is high enough to be amongst
 * the top 15 scores.  A HighScore consists of the score and the name of the
 * user who achieved that score.
 *
 * @author Joshua Thompson
 * @date 11/24/01
 * @version 1.1
 */
//Version History
//  11/24/01 Joshua Thompson added algorithm pseudocode
//  11/28/01 Joshua Thompson fixed javadoc headers and included descriptions
//			 of variables
//	2/27/02	 Antony George implemented the HighScore constructor
//	2/28/02  Antony George implemented the setName method
//	3/1/02   Antony George implemented the getScore and setScore methods

public class HighScore
{
    /**
     * The name associated with a score on the high scores list.
     */
    private String name;
    /**
     * A score sufficiently high to place the user on the high scores list
     */
    private int score;
    /**
        * Constructor for the Score Class
        *
        * @param name the name of a user
        * @param score the score of a user
        */
    public HighScore(String name, int score)
    {
        // SET name = name passed
        this.name = name;
        // SET score = score passed
        this.score = score;
    }

    /**
     * Returns the user's name
     *
     * @return the name of the user
     */
    public String getName()
    {
        // RETURN name
        return name;
    }

    /**
     * Sets the user's name to the passed value
     *
     * @param name the name of the user
     */
    public void setName(String name)
    {
        // SET name = name passed
        this.name = name;
    }

    /**
     * Returns the user's score
     *
     * @return the score of the user
     */
    public int getScore()
    {
        // RETURN score
        return score;
    }

    /**
     * Sets the user's score to the passed value
     *
     * @param score the value to set the user's score to
     */
    public void setScore(int score)
    {
        // SET score = score passed
        this.score = score;
    }
}

