/**
 * <p>The RobotColor class extends the Enumerate class and represents the
 * four colors a Robot can be.</p>
 * <p>The colors are:<br>
 * 1. Blue<br>
 * 2. Red<br>
 * 3. Green<br>
 * 4. Yellow<br>
 * </p>
 *
 * @author Joshua Thompson
 * @date 11/27/2001
 * @version 1.0
 *
 */
//Version History
//  11/27/01 Joshua Thompson added algorithm pseudocode

public class RobotColor extends Enumerate
{
    public static final RobotColor BLUE = new RobotColor("BLUE");
    public static final RobotColor RED = new RobotColor("RED");
    public static final RobotColor GREEN = new RobotColor("GREEN");
    public static final RobotColor YELLOW = new RobotColor("YELLOW");

    /**
     * The enumerated value of the color of the robot
     */
    private RobotColor color;

    /**
     * <p>Constructor - calls the constructor of the Enumerate class that
     * RobotColor inherits.</p>
     *
     * @param name the name of the direction: blue, red, green or yellow
     */
    public RobotColor (String name)
    {
        // CALL Enumerate constructor with super(name)
        super(name);
    }

    /**
     * Returns the current color
     *
     * @return RobotColor color - the current color selected
     */
    public RobotColor getColor()
    {
        // RETURN color
        return color;
    }

    /**
     * Sets the current color to the parameter passed
     *
     * @param newColor the new color to set color to
     */
    public void setColor(RobotColor newColor)
    {
        // SET color = newColor
        color = newColor;
    }
}
