/**
  * The Sokoban class is the entry point for the Sokoban game.
  *
  * @author  Joshua Thompson
  * @date    12/01/01
  * @version 1.4
  *
  */
//Version History
//  12/01/01 Joshua Thompson added java code
//  01/12/02 Joshua Thompson modified java code; added endGame method; changed
//			 the actionPerformed method and the levelFinishedDisplay method
//  01/28/02 Joshua Thompson modified the java code; added a call to set the
//			 MapRenderer as an observer of the map in the startGame() method
//  02/24/02 Kevin Blomseth seperated GUI code into SGui.java

public class Sokoban
{
    static boolean debugMode;

    /**
     * Initializes and displays the window.  This is the entry point for the game.
     *
     * @param args a string array of command line parameters.
     * <p><b>Pre-conditions:</b>none.</p>
     * <p><b>Post-conditions:</b>the game window is visible.</p>
     */
    public static void main (String[] args)
    {
        debugMode = false;
        for (int index = 0; index < args.length; index++)
        {
            if (args[index].equals("-debug"))
            {
                debugMode = true;
            }
        }
        // INIT new Sokoban window
        SGui window = new SGui(debugMode);
    }
}
