package TestTools;
import java.awt.*;
import java.awt.event.*;
import SGui;
import javax.swing.*;
import java.io.*;
import java.util.*;

/** GUIRobot is a front end to the java.awt.Robot class.
    This program reads a script file (.rsf) that contains 
    commands to the GUI robot. The commands are then
    translated into method calls to the Robot class.
    
    Required modifications:
    To use this with your own application, change the package
    and import statements in the first two lines as appropriate for your project.
    Then change every occurrence of "MyApp" to your application class name.
  */    
public class GUIRobot
{
   Hashtable keys = new Hashtable();
   
   public GUIRobot()
   {
      //create hashtable of input characters
      keys.put("0", new Integer(KeyEvent.VK_0));
      keys.put("1", new Integer(KeyEvent.VK_1));
      keys.put("2", new Integer(KeyEvent.VK_2));
      keys.put("3", new Integer(KeyEvent.VK_3));
      keys.put("4", new Integer(KeyEvent.VK_4));
      keys.put("5", new Integer(KeyEvent.VK_5));
      keys.put("6", new Integer(KeyEvent.VK_6));
      keys.put("7", new Integer(KeyEvent.VK_7));
      keys.put("8", new Integer(KeyEvent.VK_8));
      keys.put("9", new Integer(KeyEvent.VK_9));
      keys.put("a", new Integer(KeyEvent.VK_A));
      keys.put("b", new Integer(KeyEvent.VK_B));
      keys.put("c", new Integer(KeyEvent.VK_C));
      keys.put("d", new Integer(KeyEvent.VK_D));
      keys.put("e", new Integer(KeyEvent.VK_E));
      keys.put("f", new Integer(KeyEvent.VK_F));
      keys.put("g", new Integer(KeyEvent.VK_G));
      keys.put("h", new Integer(KeyEvent.VK_H));
      keys.put("i", new Integer(KeyEvent.VK_I));
      keys.put("j", new Integer(KeyEvent.VK_J));
      keys.put("k", new Integer(KeyEvent.VK_K));
      keys.put("l", new Integer(KeyEvent.VK_L));
      keys.put("m", new Integer(KeyEvent.VK_M));
      keys.put("n", new Integer(KeyEvent.VK_N));
      keys.put("o", new Integer(KeyEvent.VK_O));
      keys.put("p", new Integer(KeyEvent.VK_P));
      keys.put("q", new Integer(KeyEvent.VK_Q));
      keys.put("r", new Integer(KeyEvent.VK_R));
      keys.put("s", new Integer(KeyEvent.VK_S));
      keys.put("t", new Integer(KeyEvent.VK_T));
      keys.put("u", new Integer(KeyEvent.VK_U));
      keys.put("v", new Integer(KeyEvent.VK_V));
      keys.put("w", new Integer(KeyEvent.VK_W));
      keys.put("x", new Integer(KeyEvent.VK_X));
      keys.put("y", new Integer(KeyEvent.VK_Y));
      keys.put("z", new Integer(KeyEvent.VK_Z));
      keys.put("A", new Integer(KeyEvent.VK_A));
      keys.put("B", new Integer(KeyEvent.VK_B));
      keys.put("C", new Integer(KeyEvent.VK_C));
      keys.put("D", new Integer(KeyEvent.VK_D));
      keys.put("E", new Integer(KeyEvent.VK_E));
      keys.put("F", new Integer(KeyEvent.VK_F));
      keys.put("G", new Integer(KeyEvent.VK_G));
      keys.put("H", new Integer(KeyEvent.VK_H));
      keys.put("I", new Integer(KeyEvent.VK_I));
      keys.put("J", new Integer(KeyEvent.VK_J));
      keys.put("K", new Integer(KeyEvent.VK_K));
      keys.put("L", new Integer(KeyEvent.VK_L));
      keys.put("M", new Integer(KeyEvent.VK_M));
      keys.put("N", new Integer(KeyEvent.VK_N));
      keys.put("O", new Integer(KeyEvent.VK_O));
      keys.put("P", new Integer(KeyEvent.VK_P));
      keys.put("Q", new Integer(KeyEvent.VK_Q));
      keys.put("R", new Integer(KeyEvent.VK_R));
      keys.put("S", new Integer(KeyEvent.VK_S));
      keys.put("T", new Integer(KeyEvent.VK_T));
      keys.put("U", new Integer(KeyEvent.VK_U));
      keys.put("V", new Integer(KeyEvent.VK_V));
      keys.put("W", new Integer(KeyEvent.VK_W));
      keys.put("X", new Integer(KeyEvent.VK_X));
      keys.put("Y", new Integer(KeyEvent.VK_Y));
      keys.put("Z", new Integer(KeyEvent.VK_Z));
      //extra characters

      keys.put(" ", new Integer(KeyEvent.VK_SPACE));
      keys.put("space", new Integer(KeyEvent.VK_SPACE));
      keys.put("enter", new Integer(KeyEvent.VK_ENTER));
      keys.put("shift", new Integer(KeyEvent.VK_SHIFT));
      keys.put("esc", new Integer(KeyEvent.VK_ESCAPE));
      keys.put("del", new Integer(KeyEvent.VK_DELETE));
      keys.put("backspace", new Integer(KeyEvent.VK_BACK_SPACE));
      keys.put("capslock", new Integer(KeyEvent.VK_CAPS_LOCK));
      keys.put("ctrl", new Integer(KeyEvent.VK_CONTROL));
      keys.put("alt", new Integer(KeyEvent.VK_ALT));
      keys.put("tab", new Integer(KeyEvent.VK_TAB));
      keys.put(".", new Integer(KeyEvent.VK_PERIOD));
      keys.put("down", new Integer(KeyEvent.VK_DOWN));
      keys.put("up", new Integer(KeyEvent.VK_UP));
      keys.put("left", new Integer(KeyEvent.VK_LEFT));
      keys.put("right", new Integer(KeyEvent.VK_RIGHT));
      keys.put("-", new Integer(KeyEvent.VK_MINUS));
	  keys.put(";", new Integer(KeyEvent.VK_SEMICOLON));
	  keys.put("\\", new Integer(KeyEvent.VK_BACK_SLASH));
	  keys.put("/", new Integer(KeyEvent.VK_SLASH));

   }



   public void runScript(String[] args)
   {
      Robot rob = null; 

      //process parameters
      if (args.length < 1)
      {
         System.out.println("Usage: provide a robot script file (.rsf)");
         System.exit(0);
      }

      Reader in = null;
      BufferedReader input = null;
      //open the file for processing
      try
      {
         in = new FileReader (args[0]);
         input = new BufferedReader(in);
      }
      catch (Exception exception)
      {
         System.out.println("Unable to open file: " + args[0]);
         System.exit(0);
      }



      //-------------------------------------

      // Create an instance of the application to be controlled
      // set up frames and panels
      SGui mjf = new SGui(true);

      // set up fields, labels, and buttons
      mjf.setVisible(true);

      // create a robot to feed in GUI events
      try 
      {
         rob = new Robot();
      }
      catch (java.awt.AWTException ex)
      {
        System.err.println("Can't start Robot: " + ex);
        System.exit(0);
      }

      rob.delay(5000);         //let application load

      //Process the second command line argument, if it exists
      int DelayDuration;
      //if (args.length >= 2)
     // {
     // 	  DelayDuration = Integer.parseInt(args[1]);
  	 // }
  	 // else
  	  //{
      	  DelayDuration = 100;  // default = .1 seconds
     // }
      rob.setAutoDelay(DelayDuration);    // set delay that happens after every command


      boolean notDone = true;                   //flags when the file is done
      String line = null;                       //a line read from the file

      //process all the lines in file
      while (notDone)
      {
         try
         {
            line = input.readLine ();
            line = line.trim();   // trim whitespace
            // Ignore short lines (from Unix -> Windows transfer)
            while (line.length() < 2)
            {
                line = input.readLine ();
            }
            //System.out.println("Robot Echo: " + line);

            //if not a comment
            if (! line.startsWith("//") && ! line.startsWith("--"))
            {
               //process the line, interpreting commands
               // and calling the Robot methods
               if (line.startsWith("mouse_move"))
               {
                  line = line.substring(10);
                  StringTokenizer st = new StringTokenizer(line, ",");
                  String inStr = st.nextToken().trim();
                  int x = Integer.parseInt(inStr);
                  inStr = st.nextToken().trim();
                  int y = Integer.parseInt(inStr);
                  rob.mouseMove(x, y);
               }

               else if (line.startsWith("mouse_press"))
               {
                  line = line.substring(11);
                  StringTokenizer st = new StringTokenizer(line, ",");
                  String inStr = st.nextToken().trim();
                  int x = Integer.parseInt(inStr);
                  inStr = st.nextToken().trim();
                  int y = Integer.parseInt(inStr);
                  rob.mouseMove(x, y);
                  rob.mousePress(InputEvent.BUTTON1_MASK);
                  rob.mouseRelease(InputEvent.BUTTON1_MASK);
               }

               else if (line.startsWith("mouse_down"))
               {
                  rob.mousePress(InputEvent.BUTTON1_MASK);
               }

               else if (line.startsWith("mouse_up"))
               {
                  rob.mouseRelease(InputEvent.BUTTON1_MASK);
               }
               else if (line.startsWith("press_key"))
               {
                  line = line.substring(9);
                  line = line.trim();
                  //line = line.toLowerCase();
                  Integer keyEvent = (Integer) keys.get(line);
                  rob.keyPress(keyEvent.intValue());
               }

               else if (line.startsWith("release_key"))
               {
                  line = line.substring(11);
                  line = line.trim();
                  //line = line.toLowerCase();
                  Integer keyEvent = (Integer) keys.get(line);
                  rob.keyRelease(keyEvent.intValue());
               }

               else if (line.startsWith("type_key"))

               {
                  line = line.substring(8);
                  line = line.trim();
                  //line = line.toLowerCase();
                  Integer keyEvent = (Integer) keys.get(line);
                  rob.keyPress(keyEvent.intValue());
                  rob.keyRelease(keyEvent.intValue());
               }

               else if (line.startsWith("type_string"))

               {
                  line = line.substring(12);
                  line = line.trim();  
                 //line = line.toLowerCase();
                  rob.setAutoDelay(1);    // turn off delay for entering string

                  for (int index = 0; index < line.length(); index++)
                  {
                     char letter = line.charAt(index);
                     if (letter >= 'A' && letter <= 'Z')
                     { rob.keyPress(KeyEvent.VK_SHIFT);
                     }
                     Integer keyEvent = (Integer) keys.get(String.valueOf(letter));
                     rob.keyPress(keyEvent.intValue());
                     rob.keyRelease(keyEvent.intValue());
                     rob.keyRelease(KeyEvent.VK_SHIFT);
                  }

                  rob.setAutoDelay(DelayDuration);    // restore delay 
               }

               else if (line.startsWith("wait"))
               {
                  line = line.substring(4);
                  line = line.trim();
                  int time = Integer.parseInt(line);
                  rob.delay(time);
               }

               else
               {
                 System.out.println("***** invalid script command: " + line);
               }


//               rob.delay(500);                        //delay between comands
            } // end if
         } // end try
         catch (Exception exception)
         {
           notDone = false;
         }
      } // end loop

      //close the file
      try
      {
         if (input != null)
         {
            input.close();
         }
      }
      catch (Exception ex)      
      { System.err.println(ex); 
      }

      //make sure all special keys have been turned off
      System.out.println("Robot releasing ALT and CTRL keys");
      rob.keyRelease(KeyEvent.VK_CONTROL);
      rob.keyRelease(KeyEvent.VK_ALT);

   } // end method


   public static void main(String[] args) throws AWTException
   {
        new GUIRobot().runScript(args);
   }
}
