import junit.framework.*;
/**
 * This is a JUnit test for game.undoMove().
 * 
 * Test Method
 *      game.undoMove()
 * 
 * testUndo
 *      Tests the undo module.
 */
public class GameTest extends TestCase
{
    SGui gui;
    Game game;
    Robot first;
    Robot second;

    public GameTest (String name)
    {
        super (name);
    }

    /**
     * This method creates a game and a gui for the game
     * to reference to.
     */
    public void setUp()
    {
        gui = new SGui(true);
        game = new Game(gui);
    }

    /**
     * This method copies the initial robot to a robot,
     * then creates another robot to compare the robot to.
     * It then adds a move and undos it. 
     */
    public void testUndo()
    {
        first = game.getLocalRobot();
        gui = new SGui(true);
        game = new Game(gui);
        game.postMove(0, Direction.RIGHT);
        game.undoMove(0);
        second = game.getLocalRobot();
        assertEquals(first.getCol(), second.getCol());
        assertEquals(first.getRow(), second.getRow());
        assertEquals(first.getMoves(), second.getMoves());
    }
}
